---
title: Databases
subtitle: WIP Subqueries
layout: layouts/presentation.njk
---

{#
Incorporate
https://learn.microsoft.com/en-us/sql/relational-databases/performance/subqueries?view=sql-server-ver16
https://www.tutorialspoint.com/sql/sql-sub-queries.htm
https://docs.oracle.com/database/121/SQLRF/queries.htm#SQLRF007
https://www.geeksforgeeks.org/sql-subquery/
https://en.wikipedia.org/wiki/Select_(SQL)#Subqueries
https://en.wikipedia.org/wiki/Correlated_subquery
https://learnsql.com/blog/sql-subquery-examples/
https://www.wiseowl.co.uk/sql/exercises/standard/subqueries/4227/
#}

<section>
  <h2>Purpose of Subqueries</h2>
  <section>
    <h3>Definition</h3>
    Queries can be nested. so that the results of one query can be used in another query via a relational operator or aggregation function.
    <p>A nested query is also known as a <strong>subquery</strong>.</p>
  </section>

  <section>
  <h3>Which Problems do Subqueries Solve?</h3>
  <ul>
    <li>A query can access the results of another query</li>
    <li>Queries become more versatile by asking questions requiring other
      queries</li>


    <li class="fragment">For example, subqueries allow filtering values that
      are above or below their average
    </li>
  </ul>
  </section>

  <section>
  <h3>Which Problems do Subqueries Cause?</h3>
  <ul>
    <li>Query performance usually suffers</li>
    <li>Can be hard to read</li>
  </ul>

  {#
  <div class="fragment">
    Modern SQL ... offers solutions to some of these problems
  </div>
  #}
  </section>
</section>

<section>
  <h2>Definition</h2>
</section>

<section>
  <h2>Syntax</h2>

{#
Examples...

SELECT AVG(asset_sums)
FROM
(
    SELECT t.client, SUM(t.asset) AS asset_sums
    FROM the-table t
    GROUP BY t.client
) as inner_query
#}
</section>

<section>
  <h2>Example</h2>
  <p>Using Northwind, get all products cheaper than the average unit price.</p>
{% highlight "sql" %}
select * from Products
where Price <
(select avg(Price) from Products);
{% endhighlight %}
</section>

<section>
  <h2>Exercise</h2>
  <p>List all customers that have posted orders for more than Eur 2000.</p>

  <aside class="notes">
{% highlight "sql" %}
select o.*, sum(od.Quantity * p.Price) as total from Orders o
natural join OrderDetails od
natural join Products p
group by o.OrderID
having total >= 2000
order by o.CustomerID;

select * from Customers c
where CustomerID in
(select distinct(o.CustomerID) from Orders o
natural join OrderDetails od
natural join Products p
-- where o.OrderID = 10249
group by o.OrderID
having sum(od.Quantity * p.Price) >= 2000);
{% endhighlight %}
  </aside>
</section>




{% include 'slides/closing.njk' %}
